Unit av12e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV11_p;

function av12e(N :Integer; var SX :Array of Extended; INCX :Integer;
                var IERR :Integer): Extended; 
implementation

function av12e(N :Integer; var SX :Array of Extended; INCX :Integer;
                var IERR :Integer): Extended;
var
I,INCX1,NINCX :Integer;
AMAX,EVNORM,RNORM,SUM,X :Extended;
const
BCH :Extended = 1.0e+6;
label
_20,_30,_40,_50,_60,_70,_80;
begin

{         N- }
{        S   }
{       IN }

{      ,, }

EVNORM := 0.0e0;
AMAX := 0.0e0;
SUM := 0.0e0;
IERR := 0;
{         N }
if ( N > 0 ) 
 then goto _20;
IERR := 65;
UTAV11(IERR,7);
{  Result -    AV12D  FORTRAN }
Result := 0.0e0;
goto _80;
_20:
INCX1 := Abs(INCX);
NINCX := N*INCX1;
I := 1;
while ( I<=NINCX ) do
 begin
  if ( Abs(SX[I-1]) > AMAX ) 
   then AMAX := Abs(SX[I-1]);
_30:
  inc(I,INCX1);
 end;
if ( AMAX <> 0.0e0 ) 
 then goto _40;
{  Result -    AV12D  FORTRAN }
Result := 0.0e0;
goto _80;
_40:
if ( AMAX > BCH ) 
 then goto _60;
I := 1;
while ( I<=NINCX ) do
 begin
  SUM := SUM + SX[I-1]*SX[I-1];
_50:
  inc(I,INCX1);
 end;
EVNORM := Sqrt(SUM);
{  Result -    AV12D  FORTRAN }
Result := EVNORM;
goto _80;
_60:
RNORM := Power(2,(Floor((Ln(AMAX)/Ln(2.0e0)))) + 1.0);
I := 1;
while ( I<=NINCX ) do
 begin
  SUM := SUM + IntPower(SX[I-1]/RNORM,2);
_70:
  inc(I,INCX1);
 end;
EVNORM := RNORM*Sqrt(SUM);
{  Result -    AV12D  FORTRAN }
Result := EVNORM;
_80:
exit;
end;

end.
